Merge branch 'jc/shortstatus'
[git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6    or: $dashless show [<stash>]
7    or: $dashless drop [-q|--quiet] [<stash>]
8    or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9    or: $dashless branch <branchname> [<stash>]
10    or: $dashless [save [--keep-index] [-q|--quiet] [<message>]]
11    or: $dashless clear"
12
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 . git-sh-setup
16 require_work_tree
17 cd_to_toplevel
18
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
21
22 ref_stash=refs/stash
23
24 no_changes () {
25         git diff-index --quiet --cached HEAD --ignore-submodules -- &&
26         git diff-files --quiet --ignore-submodules
27 }
28
29 clear_stash () {
30         if test $# != 0
31         then
32                 die "git stash clear with parameters is unimplemented"
33         fi
34         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
35         then
36                 git update-ref -d $ref_stash $current
37         fi
38 }
39
40 create_stash () {
41         stash_msg="$1"
42
43         git update-index -q --refresh
44         if no_changes
45         then
46                 exit 0
47         fi
48
49         # state of the base commit
50         if b_commit=$(git rev-parse --verify HEAD)
51         then
52                 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
53         else
54                 die "You do not have the initial commit yet"
55         fi
56
57         if branch=$(git symbolic-ref -q HEAD)
58         then
59                 branch=${branch#refs/heads/}
60         else
61                 branch='(no branch)'
62         fi
63         msg=$(printf '%s: %s' "$branch" "$head")
64
65         # state of the index
66         i_tree=$(git write-tree) &&
67         i_commit=$(printf 'index on %s\n' "$msg" |
68                 git commit-tree $i_tree -p $b_commit) ||
69                 die "Cannot save the current index state"
70
71         # state of the working tree
72         w_tree=$( (
73                 rm -f "$TMP-index" &&
74                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
75                 GIT_INDEX_FILE="$TMP-index" &&
76                 export GIT_INDEX_FILE &&
77                 git read-tree -m $i_tree &&
78                 git add -u &&
79                 git write-tree &&
80                 rm -f "$TMP-index"
81         ) ) ||
82                 die "Cannot save the current worktree state"
83
84         # create the stash
85         if test -z "$stash_msg"
86         then
87                 stash_msg=$(printf 'WIP on %s' "$msg")
88         else
89                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
90         fi
91         w_commit=$(printf '%s\n' "$stash_msg" |
92                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
93                 die "Cannot record working tree state"
94 }
95
96 save_stash () {
97         keep_index=
98         while test $# != 0
99         do
100                 case "$1" in
101                 --keep-index)
102                         keep_index=t
103                         ;;
104                 -q|--quiet)
105                         GIT_QUIET=t
106                         ;;
107                 *)
108                         break
109                         ;;
110                 esac
111                 shift
112         done
113
114         stash_msg="$*"
115
116         git update-index -q --refresh
117         if no_changes
118         then
119                 say 'No local changes to save'
120                 exit 0
121         fi
122         test -f "$GIT_DIR/logs/$ref_stash" ||
123                 clear_stash || die "Cannot initialize stash"
124
125         create_stash "$stash_msg"
126
127         # Make sure the reflog for stash is kept.
128         : >>"$GIT_DIR/logs/$ref_stash"
129
130         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
131                 die "Cannot save the current status"
132         say Saved working directory and index state "$stash_msg"
133
134         git reset --hard ${GIT_QUIET:+-q}
135
136         if test -n "$keep_index" && test -n $i_tree
137         then
138                 git read-tree --reset -u $i_tree
139         fi
140 }
141
142 have_stash () {
143         git rev-parse --verify $ref_stash >/dev/null 2>&1
144 }
145
146 list_stash () {
147         have_stash || return 0
148         git log --no-color --pretty=oneline -g "$@" $ref_stash -- |
149         sed -n -e 's/^[.0-9a-f]* refs\///p'
150 }
151
152 show_stash () {
153         flags=$(git rev-parse --no-revs --flags "$@")
154         if test -z "$flags"
155         then
156                 flags=--stat
157         fi
158
159         w_commit=$(git rev-parse --verify --default $ref_stash "$@") &&
160         b_commit=$(git rev-parse --verify "$w_commit^") &&
161         git diff $flags $b_commit $w_commit
162 }
163
164 apply_stash () {
165         unstash_index=
166
167         while test $# != 0
168         do
169                 case "$1" in
170                 --index)
171                         unstash_index=t
172                         ;;
173                 -q|--quiet)
174                         GIT_QUIET=t
175                         ;;
176                 *)
177                         break
178                         ;;
179                 esac
180                 shift
181         done
182
183         if test $# = 0
184         then
185                 have_stash || die 'Nothing to apply'
186         fi
187
188         # stash records the work tree, and is a merge between the
189         # base commit (first parent) and the index tree (second parent).
190         s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
191         w_tree=$(git rev-parse --quiet --verify "$s:") &&
192         b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
193         i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
194                 die "$*: no valid stashed state found"
195
196         git update-index -q --refresh &&
197         git diff-files --quiet --ignore-submodules ||
198                 die 'Cannot apply to a dirty working tree, please stage your changes'
199
200         # current index state
201         c_tree=$(git write-tree) ||
202                 die 'Cannot apply a stash in the middle of a merge'
203
204         unstashed_index_tree=
205         if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
206                         test "$c_tree" != "$i_tree"
207         then
208                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
209                 test $? -ne 0 &&
210                         die 'Conflicts in index. Try without --index.'
211                 unstashed_index_tree=$(git write-tree) ||
212                         die 'Could not save index tree'
213                 git reset
214         fi
215
216         eval "
217                 GITHEAD_$w_tree='Stashed changes' &&
218                 GITHEAD_$c_tree='Updated upstream' &&
219                 GITHEAD_$b_tree='Version stash was based on' &&
220                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
221         "
222
223         if test -n "$GIT_QUIET"
224         then
225                 export GIT_MERGE_VERBOSITY=0
226         fi
227         if git merge-recursive $b_tree -- $c_tree $w_tree
228         then
229                 # No conflict
230                 if test -n "$unstashed_index_tree"
231                 then
232                         git read-tree "$unstashed_index_tree"
233                 else
234                         a="$TMP-added" &&
235                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
236                         git read-tree --reset $c_tree &&
237                         git update-index --add --stdin <"$a" ||
238                                 die "Cannot unstage modified files"
239                         rm -f "$a"
240                 fi
241                 squelch=
242                 if test -n "$GIT_QUIET"
243                 then
244                         squelch='>/dev/null 2>&1'
245                 fi
246                 eval "git status $squelch" || :
247         else
248                 # Merge conflict; keep the exit status from merge-recursive
249                 status=$?
250                 if test -n "$unstash_index"
251                 then
252                         echo >&2 'Index was not unstashed.'
253                 fi
254                 exit $status
255         fi
256 }
257
258 drop_stash () {
259         have_stash || die 'No stash entries to drop'
260
261         while test $# != 0
262         do
263                 case "$1" in
264                 -q|--quiet)
265                         GIT_QUIET=t
266                         ;;
267                 *)
268                         break
269                         ;;
270                 esac
271                 shift
272         done
273
274         if test $# = 0
275         then
276                 set x "$ref_stash@{0}"
277                 shift
278         fi
279         # Verify supplied argument looks like a stash entry
280         s=$(git rev-parse --verify "$@") &&
281         git rev-parse --verify "$s:"   > /dev/null 2>&1 &&
282         git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
283         git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
284                 die "$*: not a valid stashed state"
285
286         git reflog delete --updateref --rewrite "$@" &&
287                 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
288
289         # clear_stash if we just dropped the last stash entry
290         git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
291 }
292
293 apply_to_branch () {
294         have_stash || die 'Nothing to apply'
295
296         test -n "$1" || die 'No branch name specified'
297         branch=$1
298
299         if test -z "$2"
300         then
301                 set x "$ref_stash@{0}"
302         fi
303         stash=$2
304
305         git checkout -b $branch $stash^ &&
306         apply_stash --index $stash &&
307         drop_stash $stash
308 }
309
310 # Main command set
311 case "$1" in
312 list)
313         shift
314         if test $# = 0
315         then
316                 set x -n 10
317                 shift
318         fi
319         list_stash "$@"
320         ;;
321 show)
322         shift
323         show_stash "$@"
324         ;;
325 save)
326         shift
327         save_stash "$@"
328         ;;
329 apply)
330         shift
331         apply_stash "$@"
332         ;;
333 clear)
334         shift
335         clear_stash "$@"
336         ;;
337 create)
338         if test $# -gt 0 && test "$1" = create
339         then
340                 shift
341         fi
342         create_stash "$*" && echo "$w_commit"
343         ;;
344 drop)
345         shift
346         drop_stash "$@"
347         ;;
348 pop)
349         shift
350         if apply_stash "$@"
351         then
352                 test -z "$unstash_index" || shift
353                 drop_stash "$@"
354         fi
355         ;;
356 branch)
357         shift
358         apply_to_branch "$@"
359         ;;
360 *)
361         if test $# -eq 0
362         then
363                 save_stash &&
364                 say '(To restore them type "git stash apply")'
365         else
366                 usage
367         fi
368         ;;
369 esac